//Initialize global variables
var PAGE_WIDTH = 1;
var PAGE_HEIGHT = 1;

var manager = null;
// PLAY_STATUS: state of the play button
var PLAY_STATUS_PLAYING = 4;
var PLAY_STATUS_PAUSED = 3;
var PLAY_STATUS_END = 0;
// WORK_STATUS: state of the spinny widget
var WORK_STATUS_BUSY = 2;
var WORK_STATUS_LOADING = 1;
var WORK_STATUS_IDLE = 0;

//browser sniffing... sigh
// bug 23154: updated 12/10/13 JBW to properly detect IE 11 
// var MSIE = (navigator.appName == "Microsoft Internet Explorer");
var MSIE = isMSIE();

var IMOB = (navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)) || (navigator.userAgent.match(/iPad/i));
if (IMOB == null)
{
    IMOB = false;
}

var bIsAndroid = false;
if (navigator.userAgent.match(/Android/i) != null)
{
    bIsAndroid = true;
    IMOB = true;
}

var DEBUG = false;
var hasPageSounds = false;
var autoplayPageSounds = !IMOB;

// from http://stackoverflow.com/questions/17907445/how-to-detect-ie11
function isMSIE() {
    return ((navigator.appName == 'Microsoft Internet Explorer') || ((navigator.appName == 'Netscape') &&
            (new RegExp("Trident/.*rv:([0-9]{1,}[\.0-9]{0,})").exec(navigator.userAgent) != null)));
}

function hasPageSound(idx) {
    if (pages[idx][1] != "" && pages[idx][1] != undefined)
    {
        return true;
    } else {
        return false;
    }
}

window.onload = function()
{
    if (typeof hasRequestedVersion != "undefined" && hasRequestedVersion)
    {
        return false;
    }

    //--check for page sounds 
    var pagesLength = (typeof pages != "undefined") ? pages.length : 0;
    for (var ctr = 0; ctr < pagesLength; ctr++)
    {
        if (hasPageSound(ctr))
        {
            hasPageSounds = true;
            break;
        }
    }
    //--end check for page sounds

    if (IMOB)
    {
        if (hasPageSounds)
        {
            autoadvance = false;
        }
    }

    if (typeof pages == "undefined" || pages.length < 1)
    {
        alert("Invalid image count. Cannot show slideshow.");
        return;
    }
    addStyles();

    //see if there is a viewport defined, if not add one
    var viewport = document.getElementById('viewport');
    if (!viewport)
    {
        viewport = document.createElement('div');
        viewport.setAttribute('id', 'viewport');
        viewport.style.position = 'absolute';
        viewport.style.width = PAGE_WIDTH + "px";
        viewport.style.height = PAGE_HEIGHT + "px";
        viewport.style.overflow = "hidden";
        viewport.style.background = "#FFFFFF";
        viewport.style.border = "2px solid #000";

        document.body.appendChild(viewport);
        document.body.style.overflow = "hidden";
    }

    viewport.style.position = 'absolute';
    viewport.style.overflow = 'hidden';
    document.body.style.overflow = 'hidden';

    var drawingCanvas = document.createElement('canvas'), context;
    if (DEBUG || !drawingCanvas.getContext)
    {
        drawingCanvas = null;
    } else {
        drawingCanvas.width = PAGE_WIDTH;
        drawingCanvas.height = PAGE_HEIGHT;
        context = drawingCanvas.getContext('2d');

        var canvasDiv = document.createElement('div');
        canvasDiv.setAttribute('id', 'canvasDiv');
        canvasDiv.style.background = "#FFFFFF";

        canvasDiv.appendChild(drawingCanvas);
        viewport.appendChild(canvasDiv);
    }

    if (hasPageSounds && !autoplayPageSounds)
        autohideControls = false;

    manager = new Manager(drawingCanvas, viewport);
    if (typeof transition != "undefined") {
        manager.transitionName = transition;
    }
}


window.onunload = function() {
    if (manager) {
        manager.endAll();
    }
}

window.onbeforeunload = function() {
    if (manager) {
        manager.endAll();
    }
}

window.onresize = function() {
    updateLayout();
}

function supportsFullScreen() {
    return document.fullscreenEnabled || 
            document.webkitFullscreenEnabled || 
            document.mozFullScreenEnabled ||
            document.msFullscreenEnabled;
}

function isFullScreen() {
// are we full-screen?
if (
    document.fullscreenElement ||
    document.webkitFullscreenElement ||
    document.mozFullScreenElement ||
    document.msFullscreenElement
) {
return true;
}    
return false;
}

function enterFullScreen(element) {
    // go full-screen
    if (element.requestFullscreen) {
        element.requestFullscreen();
    } else if (element.webkitRequestFullscreen) {
        element.webkitRequestFullscreen();
    } else if (element.mozRequestFullScreen) {
        element.mozRequestFullScreen();
    } else if (element.msRequestFullscreen) {
        element.msRequestFullscreen();
    }    
}
    
function exitFullScreen() {
    // exit full-screen
    if (document.exitFullscreen) {
        document.exitFullscreen();
    } else if (document.webkitExitFullscreen) {
        document.webkitExitFullscreen();
    } else if (document.mozCancelFullScreen) {
        document.mozCancelFullScreen();
    } else if (document.msExitFullscreen) {
        document.msExitFullscreen();
    }    
}

function updateLayout()
{
    var pagewidth = PAGE_WIDTH;
    var pageheight = PAGE_HEIGHT;

    var winPadding = 0;

    var newW, newH;
    var winW = (document.documentElement.clientWidth ? document.documentElement.clientWidth : document.body.clientWidth);
    var winH = (document.documentElement.clientHeight ? document.documentElement.clientHeight : document.body.clientHeight);

    if (winW <= 0 || winH <= 0)
    {
        setTimeout("updateLayout()", 50);
        return;
    }

    winW -= (winPadding * 2);
    winH -= (winPadding * 2);

    newW = winW;
    newH = winH;
    if (winW > winH)
    {
        newW = (newH * pagewidth) / pageheight;
        if (newW > winW)
        {
            newW = winW;
            newH = (newW * pageheight) / pagewidth;
        }
    } else {
        newH = (newW * pageheight) / pagewidth;
        if (newH > winH)
        {
            newH = winH;
            newW = (newH * pagewidth) / pageheight;
        }
    }
    document.body.style.overflow = "hidden";

    var vp = document.getElementById('viewport');

    var posX = (winW / 2 - newW / 2) + winPadding;
    var posY = (winH / 2 - newH / 2) + winPadding;

    vp.style.width = newW + "px";
    vp.style.height = newH + "px";

    vp.style.left = Math.floor(posX) + "px";
    vp.style.top = Math.floor(posY) + "px";

    if (manager && manager.canvas)
    {
        document.getElementById('canvasDiv').style.width = newW + "px";
        document.getElementById('canvasDiv').style.height = newH + "px";
        manager.canvas.width = newW;
        manager.canvas.height = newH;
        if (manager.target0)
        {
            manager.paint(manager.transitionValue);
        }
    }
}

function addStyles()
{
    var cssCode = "html {\nheight: 100%;\nbackground: #FFFFFF;\n}\n\n.cntrl_grd {\nbackground-color: rgba(255,255,255,0.5); padding: 4px;\nborder-style:solid;\nborder-width:0px;\nborder-color: rgba(250,250,250,0.5);\nheight:35px;\n}\n";

    var styleElement = document.createElement("style");
    styleElement.type = "text/css";
    if (styleElement.styleSheet)
    {
        styleElement.styleSheet.cssText = cssCode;
    } else {
        styleElement.appendChild(document.createTextNode(cssCode));
    }
    document.getElementsByTagName("head")[0].appendChild(styleElement);
}


//////////////////////////////////////////////////////////////////////////////////////////////////
//Manager
function Manager(canvas, viewport)
{
    this.canvas = canvas;
    this.viewport = viewport;
    //div parent of canvas

    this._playStatus = null; //1==playing, 0==paused, -1==end
    this._workStatus = WORK_STATUS_IDLE;
    this.controls = new Controls(this);
    this.controls.showControls(autohideControls);
    
    this.target0 = null;
    this.target1 = null;
    this.currentIndex = 0;
    this.loaded = false;

    this.pageTimer = null;
    this.transitionValue = 0.0;
    this.transitionTimer = null;
    this.transitionName = null;
    this.managedTransition = null;//transition object

    //get the first image loading
    this.target0 = new Image();
    this.target0.onload = function()
    {
        //slight delay before firing off event
        setTimeout(function()
        {
            manager.targetLoaded(manager.target0);
        }, 50);
    };
    this.target0.onerror = function()
    {
        manager.imageError('target0');
    };
    this.target0.src = pages[this.currentIndex][0];

    //start up the background sounds
    if (backgroundSound && !IMOB)
    {
        var bgElement = this.playSound("background_sound", backgroundSound, true);
        if (bgElement && (typeof bgElement !== "undefined"))
        {
            bgElement.play();
        }
    }
    this.setPlayStatus(PLAY_STATUS_PLAYING);
}

Manager.prototype.setPlayStatus = function(newStatus)
{
    this._playStatus = newStatus;
    this.controls.update();
}

Manager.prototype.getPlayStatus = function()
{
    return this._playStatus;
}

Manager.prototype.setWorkStatus = function(newStatus)
{
    this._workStatus = newStatus;
    this.controls.update();
}

Manager.prototype.getWorkStatus = function()
{
    return this._workStatus;
}

Manager.prototype.targetLoaded = function(src)
{
    ///var src = arguments[0][0].currentTarget;
    if (src == this.target0)
    {
        //draw first image to canvas, get something showing
        //TODO: Assume all images are the same dimension and the canvas is
        //proportional to the images...

        if (PAGE_WIDTH != this.target0.width || PAGE_HEIGHT != this.target0.height)
        {
            PAGE_WIDTH = this.target0.width;
            PAGE_HEIGHT = this.target0.height;
            window.updateLayout();
        }

        if (!this.canvas)
        {
            this.target0.style.position = 'absolute';
            this.target0.style.x = 0;
            this.target0.style.y = 0;
            this.target0.style.width = '100%';
            this.target0.style.height = '100%';
            this.target0.style.opacity = 1.0;
            this.target0.style.filter = 'alpha(opacity = 100)';

            if (this.viewport.hasChildNodes())
            {
                this.viewport.insertBefore(this.target0, this.viewport.childNodes[0]);
            } else {
                this.viewport.appendChild(this.target0);
            }
        } else {
            //draw the image
            var context = this.canvas.getContext('2d');
            context.drawImage(this.target0, 0, 0, this.canvas.width, this.canvas.height);
        }

        this.start();
    } else if (src == this.target1) {
        //the second image is loaded, start the transition timer
        this.setupTransition();
        this.updateTransition();

    }
};

Manager.prototype.updateTransition = function()
{
    //make sure images are all ready to go
    this.setWorkStatus(WORK_STATUS_BUSY);
    var painted = this.paint(this.transitionValue);
    if (painted)
    {
        this.transitionValue += 0.05;
    }
    if (this.transitionValue <= 1.0)
    {
        this.transitionTimer = setTimeout(function()
        {
            manager.updateTransition();
        }, 50);
    } else {
        //the transition is done rendering.
        this.end();
        this.setupPage();
    }
}

Manager.prototype.setupTransition = function()
{
    //setup the transition
    if (!this.canvas)
    {
        this.managedTransition = new HTMLFade(this.viewport, this.target0, this.target1);
    } else {
        if (typeof this.transitionName != "undefined") {
            this.transitionName = this.transitionName.toLowerCase();
            if (this.transitionName == "random") {
                var ran = Math.random();
                if (ran < 0.3)
                {
                    this.managedTransition = new Shatter(this.canvas, this.target0, this.target1);
                } else if (ran < 0.7) {
                    this.managedTransition = new Swivel(this.canvas, this.target0, this.target1);
                } else {
                    this.managedTransition = new Fade(this.canvas, this.target0, this.target1);
                }
            } else if (this.transitionName == "shatter") {
                this.managedTransition = new Shatter(this.canvas, this.target0, this.target1);
            } else if (this.transitionName == "swivel") {
                this.managedTransition = new Swivel(this.canvas, this.target0, this.target1);
            } else {
                this.managedTransition = new Fade(this.canvas, this.target0, this.target1);
            }
        } else {
            this.managedTransition = new Fade(this.canvas, this.target0, this.target1);
        }
    }
    this.managedTransition.begin();

    //images are loaded

};

//start timers and background/page sounds
Manager.prototype.start = function()
{
    var blnPaused = false;
    //If the project has reached the end and the play button
    //is clicked, restart the project
    if (this.getPlayStatus() == PLAY_STATUS_END && this.currentIndex != 0)
    {
        this.currentIndex = 0;
        this.target0.onerror = function()
        {
            manager.imageError('target0');
        };
        this.target0.src = pages[this.currentIndex][0];
        //start up the background sounds
        if (backgroundSound && !IMOB)
        {
            var bgElement = this.playSound("background_sound", backgroundSound, true);
            if (bgElement && (typeof bgElement !== "undefined"))
            {
                bgElement.play();
            }
        }
        this.setPlayStatus(PLAY_STATUS_PLAYING);

        return;

    } else if (this.getPlayStatus() == PLAY_STATUS_PAUSED) {
        blnPaused = false;
        if (document.getElementById("background_sound") && document.getElementById("background_sound").tagName.toLowerCase() == "audio")
        {
            this.playSound("background_sound", backgroundSound, true);
        }
        if (document.getElementById("page_sound") && document.getElementById("page_sound").tagName.toLowerCase() == "audio")
        {
            document.getElementById("page_sound").play();
        }
    }

    if (!blnPaused)
    {
        this.setupTransition();
    }

    //start up the background sounds
    //multiple sounds not supported on iOS browser
    if (backgroundSound && !IMOB)
    {
        var bgElement = this.playSound("background_sound", backgroundSound, true);
        if (bgElement)
        {
            bgElement.play();
        }
    }

    if (!blnPaused)
    {
        this.setupPage();
    }

    this.setPlayStatus(PLAY_STATUS_PLAYING);
}

//stop all sounds, 
Manager.prototype.endAll = function()
{
    this.end();
    this.stopSound('background_sound', false);
    this.setPlayStatus(PLAY_STATUS_END);
}

Manager.prototype.end = function()
{
    //paint the end state of the current slide

    //stop page_sound
    this.stopSound('page_sound', false);

    if (this.transitionTimer)
    {
        clearTimeout(this.transitionTimer);
        this.transitionTimer = null;
    }
    if (this.pageTimer)
    {
        clearTimeout(this.pageTimer);
        this.pageTimer = null;
    }

    this.managedTransition.end();

    //swap targets
    if (pages.length > 1)
    {
        this.target0 = this.target1;
    }
};


Manager.prototype.setupPage = function()
{
    this.transitionValue = 0.0;

    var sound = pages[this.currentIndex][1];
    var t = pages[this.currentIndex][2];
    if (t > 0 && t < 250)
    {
        t = 250; //minumum view time
    }

    //either start the timer of when to go to the next page, or
    //wait until the sound is loaded to begin the timer
    if (sound)
    {
        var audioElement = this.playSound("page_sound", sound, false);
        if (audioElement)
        {
            if ((autoadvance || IMOB) && t >= 0)
            {
                audioElement.addEventListener("ended", function()
                {
                    if (manager.getPlayStatus() == PLAY_STATUS_PLAYING)
                    {
                        manager.next();
                    }
                });
                if (!IMOB)
                    t = -1; //dont set the page timer to advance
            }

            if (autoplayPageSounds) {
                if (audioElement.loaded)
                {
                    audioElement.play();
                } else {
                    audioElement.addEventListener("loadeddata", function()
                    {
                        audioElement.play();
                    }, true);
                }
            }

        }
    }

    if (autoadvance && t >= 0)
    {
        this.pageTimer = setTimeout(function()
        {
            if (manager.getPlayStatus() == PLAY_STATUS_PLAYING)
            {
                manager.next();
            }
        }, t);
    }
    this.setWorkStatus(WORK_STATUS_IDLE);
    this.controls.update();
}

Manager.prototype.pause = function()
{
    if (this.transitionTimer)
    {
        clearTimeout(this.transitionTimer);
        this.transitionTimer = null;
    }
    if (this.pageTimer)
    {
        clearTimeout(this.pageTimer);
        this.pageTimer = null;
    }
    //paint end state of transitions
    this.managedTransition.end();

    //pause page_sound
    this.stopSound('background_sound', true);
    this.stopSound('page_sound', true);

    this.setPlayStatus(PLAY_STATUS_PAUSED);
}

Manager.prototype.imageError = function(target)
{
    //error loading image, set a placeholder
    var placeholder;
    if (!this.canvas) {
        placeholder = document.createElement("div");
        placeholder.style.backgroundColor = "#DDDDDD";
        placeholder.style.borderStyle = "double";
        placeholder.style.borderWidth = "6px";
        placeholder.style.borderColor = "#BAD2F4";
        placeholder.style.textAlign = "center";
        placeholder.style.horiztonalAlign = "middle";

        var msgNode = document.createElement('span');
        msgNode.style.fontSize = "30px";
        msgNode.style.fontFamily = "sans-serif";
        msgNode.style.color = "#FFFFFF";
        msgNode.style.lineHeight = "15"

        msgNode.appendChild(document.createTextNode('No image available'));
        placeholder.appendChild(msgNode);
    } else {
        placeholder = document.createElement("canvas");
        placeholder.width = (this.target0) ? this.target0.width : (this.target1) ? this.target1.width : this.canvas.width;
        placeholder.height = (this.target0) ? this.target0.height : (this.target1) ? this.target1.height : this.canvas.height;

        var context = placeholder.getContext('2d');
        context.fillStyle = "#DDDDDD";
        context.fillRect(0, 0, placeholder.width, placeholder.height);
        context.strokeStyle = "#BAD2F4";
        context.lineWidth = 2;
        context.strokeRect(0, 0, placeholder.width, placeholder.height);
        context.strokeRect(4, 4, placeholder.width - 8, placeholder.height - 8);

        context.font = "30px Arial";
        context.fillStyle = "#FFFFFF";
        context.textAlign = "center";
        context.fillText("No image available", placeholder.width / 2, placeholder.height / 2 - 15);
        context.save();
    }

    if (target == 'target0') {
        this.target0 = placeholder;
        setTimeout(function() {
            manager.targetLoaded(manager.target0)
        }, 50);
    } else {
        this.target1 = placeholder;
        setTimeout(function() {
            manager.targetLoaded(manager.target1)
        }, 50);
    }
}

Manager.prototype.next = function()
{
    //first paint the end if a transition is active
    if (this.transitionValue != 0.0)
    {
        this.end();
    }

    //stop page_sound
    this.stopSound('page_sound', false);
    this.transitionValue = 0.0;

    if (!looping && this.currentIndex == pages.length - 1)
    {
        this.endAll();
        return;
    }

    this.currentIndex++;
    if (this.currentIndex >= pages.length)
    {
        this.currentIndex = 0;
    }

    //if currently paused, start the background sound again
    if (this.getPlayStatus() == PLAY_STATUS_PAUSED) {
        if (backgroundSound && !IMOB)
        {
            var bgElement = this.playSound("background_sound", backgroundSound, true);
            if (bgElement)
            {
                bgElement.play();
            }
        }
    }


    this.target1 = new Image();
    this.target1.onload = function()
    {
        manager.targetLoaded(manager.target1);
    };
    this.target1.onerror = function()
    {
        manager.imageError('target1');
    };
    this.target1.src = pages[this.currentIndex][0];
    this.setWorkStatus(WORK_STATUS_LOADING);
}

Manager.prototype.previous = function()
{
    //first paint the end if a transition is active
    if (this.transitionValue != 0.0)
    {
        this.end();
    }

    //stop page_sound
    this.stopSound('page_sound', false);
    this.transitionValue = 0.0;


    if (!looping && this.currentIndex == 0)
    {
        this.end();
        return;
    } 

    if (this.target1)
    {
        this.target0 = this.target1;
    }

    this.currentIndex -= 1;
    if (this.currentIndex < 0)
    {
        this.currentIndex = pages.length - 1;
    }

    //if currently paused, start the background sound again
    if (this.getPlayStatus() == PLAY_STATUS_PAUSED || this.getPlayStatus() == PLAY_STATUS_END) {
        this.setPlayStatus(PLAY_STATUS_PAUSED);
        if (backgroundSound && !IMOB)
        {
            var bgElement = this.playSound("background_sound", backgroundSound, true);
            if (bgElement)
            {
                bgElement.play();
            }
        }

    }


    this.target1 = new Image();
    this.target1.onload = function()
    {
        manager.targetLoaded(manager.target1);
    };
    this.target1.onerror = function()
    {
        manager.imageError('target1');
    };
    this.target1.src = pages[this.currentIndex][0];
    this.setWorkStatus(WORK_STATUS_LOADING);
}

Manager.prototype.paint = function(value)
{
    if (!this.target0)
    {
        return;
    }

    if (!this.managedTransition)
    {
        //draw the image we are translating to to the canvas
        if (!this.canvas)
        {
            this.viewport.appendChild(this.target1);
            this.viewport.removeChild(this.target0);
        } else {
            var context = this.canvas.getContext('2d');
            if (this.target1)
            {
                context.drawImage(this.target1, 0, 0, this.canvas.width, this.canvas.height);
            } else if (this.target0) {
                context.drawImage(this.target0, 0, 0, this.canvas.width, this.canvas.height);
            }
        }
        return false;
    }
    this.managedTransition.setTarget0(this.target0);
    this.managedTransition.setTarget1(this.target1);
    this.managedTransition.paint(value);
    return true;
};

Manager.prototype.stopSound = function(id, paused)
{
    var snd = document.getElementById(id);
    if (!snd)
    {
        return;
    }

    try
    {
        //if the element is and AUDIO element, pause and remove
        //otherwise deal with the source
        if (snd.tagName.toLowerCase() == "audio")
        {
            // added code to test if the sound exists to prevent js errors (particularly ie9).
            if (snd.duration > 0)
            {
                snd.pause();

                //if just pausing, then leave the sound elements in place
                if (paused)
                {
                    return;
                }
            }

            snd.src = null;
            snd.parentNode.removeChild(snd);

            //also remove the play button if it exists
            var pb = document.getElementById('pageSoundPlayButton');
            if (pb)
            {
                pb.onclick = null;
                pb.parentNode.removeChild(pb);
            }
        } else {
            if (MSIE)
            {
                snd.src = "";
            } else {
                snd.innerHTML = "";
            }
        }
    } catch (e) {
    }
}

Manager.prototype.playSound = function(id, soundfile, loop)
{
    if (typeof hasRequestedVersion != "undefined" && hasRequestedVersion)
    {
        return false;
    }
    if (!soundfile || soundfile == "")
    {
        return null;
    }

    //see that an audio element was created and it supports the filetype
    if (this.canPlay(soundfile))
    {
        var audioElement = document.getElementById(id);
        if (audioElement)
        {
            //if the src is the same, then just restart the sound
            if (audioElement.src && audioElement.src.indexOf(soundfile) > -1)
            {
                audioElement.play();
                return null;
            }

            audioElement.pause();
            audioElement.src = null;
            audioElement.parentNode.removeChild(audioElement);
        }
        audioElement = document.createElement('audio');
        audioElement.setAttribute('id', id);
        audioElement.setAttribute('preload', 'auto');
        audioElement.setAttribute('src', soundfile);
        audioElement.setAttribute('src', audioElement.src.replace(/https/, "http"));

        if (loop)
        {
            audioElement.setAttribute('loop', 'loop');
        }

        if (IMOB)
        {
            //add a button to the screen to allow sound playback
            var pb = document.getElementById("pageSoundPlayButton");
            if (!pb)
            {
                pb = document.createElement("canvas");
                pb.setAttribute('id', 'pageSoundPlayButton');
                pb.width = 100;
                pb.height = 100;
                pb.style.position = "absolute";
                pb.style.top = "10px";
                pb.style.left = "10px";
                pb.style.width = "100px";
                pb.style.height = "100px";
                this.drawPlayButton(pb);

                pb.onmouseover = function()
                {
                    pb.style.opacity = 0.7;
                    pb.style.filter = 'alpha(opacity=70)';
                }
                pb.onmouseup = function()
                {
                    pb.style.opacity = 0.7;
                    pb.style.filter = 'alpha(opacity=70)';
                }
                pb.onmousedown = function()
                {
                    pb.style.opacity = 0.9;
                    pb.style.filter = 'alpha(opacity=90)';
                }
                pb.onmouseout = function()
                {
                    pb.style.opacity = 0.5;
                    pb.style.filter = 'alpha(opacity=30)';
                }
                pb.style.opacity = 0.5;
                pb.style.filter = 'alpha(opacity=30)';
            }

            pb.onclick = function()
            {
                //stop auto page timer               
                if (manager.pageTimer)
                {
                    clearTimeout(manager.pageTimer);
                    manager.pageTimer = null;
                }

                audioElement.play();
            }
            pb.alt = "PLAY #" + this.currentIndex;
            this.canvas.parentNode.appendChild(pb);
        }

        document.body.appendChild(audioElement);
        audioElement.load();
        return audioElement;
    }

    //add bgsound element
    var snd = document.getElementById(id);
    if (MSIE)
    {
        if (!snd)
        {
            snd = document.createElement('bgsound');
            snd.setAttribute('id', id);
            snd.setAttribute('autostart', 'true');
            if (loop)
            {
                snd.setAttribute('loop', '-1');
            } else {
                snd.setAttribute('loop', '1');
            }
            document.getElementsByTagName('head')[0].appendChild(snd);
        }
        snd.src = "";
        snd.src = soundfile;
    } else {
        if (!snd)
        {
            snd = document.createElement('span');
            snd.setAttribute('id', id);
            document.body.appendChild(snd);
        }
        snd.innerHTML = "<embed id=\"" + id + "_sound\" src=\"" + soundfile + "\" hidden=\"true\" autostart=\"true\" loop=\"" + loop + "\" />";
    }
}
//test if the filetype is supported on this browser is AUDIO tag

Manager.prototype.canPlay = function(soundfile)
{
    var audio = document.createElement('audio');
    if (!audio || !audio.canPlayType)
    {
        return false;
    }

    //audio/mp3
    //audio/mpeg
    //audio/mpeg; codecs="mp3"
    //audio/mp4
    //audio/wav
    //audio/ogg
    var type = soundfile.split('.').pop();
    if (type == "mp3")
    {
        return "" != audio.canPlayType('audio/mp3') || "" != audio.canPlayType('audio/mpeg') || "" != audio.canPlayType('audio/mpeg; codecs="mp3"');
    } else if (type == "wav") {
        return "" != audio.canPlayType('audio/wav');
    } else if (type == "ogg") {
        return "" != audio.canPlayType('audio/mp4');
    } else if (type == "mp4") {
        return "" != audio.canPlayType('audio/ogg') || "" != audio.canPlayType('audio/ogg; codecs="vorbis"');
    }

    //unknown filetype
    return false;
}

//draw sound control arrow for mobile
Manager.prototype.drawPlayButton = function(canvasElement) {
    var x = 0;
    var y = 0;
    var width = 100;
    var height = 100;
    var radius = 10;


    var context = canvasElement.getContext('2d');

    //draw rounded rect
    context.fillStyle = "#676767";
    context.beginPath();
    context.moveTo(x + radius, y);
    context.lineTo(x + width - radius, y);
    context.arcTo(x + width, y, x + width, y + radius, radius);
    context.lineTo(x + width, y + height - radius);
    context.arcTo(x + width, y + height, x + width - radius, y + height, radius);
    context.lineTo(x + radius, y + height);
    context.arcTo(x, y + height, x, y + height - radius, radius);
    context.lineTo(x, y + radius);
    context.arcTo(x, y, x + radius, y, radius);
    context.closePath();
    context.fill();

    //draw arrow
    context.fillStyle = "#FFFFFF";
    context.strokeStyle = "#CDCDCD";
    context.lineWidth = 3;
    context.beginPath();
    context.moveTo(32, 25)
    context.lineTo(75, 50);
    context.lineTo(32, 75);
    context.closePath();
    context.stroke();
    context.fill();
}


Manager.prototype.enterFullScreen = function() {
    enterFullScreen(document.getElementById('viewport'));
    this.controls.enterFullScreen.style.display = 'none';
    this.controls.exitFullScreen.style.display = 'inline';        
}

Manager.prototype.exitFullScreen = function() {
    exitFullScreen();
    this.controls.enterFullScreen.style.display = 'inline';
    this.controls.exitFullScreen.style.display = 'none';                   
}

function monitorFullScreen() {
    if (supportsFullScreen()) {
        if (isFullScreen()) {
            manager.controls.enterFullScreen.style.display = 'none';
            manager.controls.exitFullScreen.style.display = 'inline';        
        } else {
            manager.controls.enterFullScreen.style.display = 'inline';
            manager.controls.exitFullScreen.style.display = 'none';               
        }
    }
};

// end Manager
//////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////
//HTMLFade transition, uses opacity to adjust images (non-HTML5 support)
function HTMLFade(viewport, target0, target1)
{
    this.viewport = viewport;
    this.setTarget0(target0)
    this.setTarget1(target1);
}
;

HTMLFade.prototype.insertElement = function(element)
{
    //insert the element at the bottom of the elements in the viewport
    if (this.viewport.hasChildNodes())
    {
        this.viewport.insertBefore(element, this.viewport.childNodes[0]);
    } else {
        this.viewport.appendChild(element);
    }
};

HTMLFade.prototype.setTarget0 = function(target)
{
    this.target0 = target;
    if (!this.target0)
    {
        return;
    }

    this.target0.style.position = 'absolute';
    this.target0.style.x = 0;
    this.target0.style.y = 0;
    this.target0.style.width = '100%';
    this.target0.style.height = '100%';
    this.target0.style.opacity = 1.0;
    this.target0.style.filter = 'alpha(opacity = 100)';

    if (!this.target0.parentNode)
    {
        this.insertElement(this.target0);
    }
};

HTMLFade.prototype.setTarget1 = function(target)
{
    this.target1 = target;
    if (!this.target1)
    {
        return;
    }

    this.target1.style.position = 'absolute';
    this.target1.style.x = 0;
    this.target1.style.y = 0;
    this.target1.style.width = '100%';
    this.target1.style.height = '100%';
    this.target1.style.opacity = 0.0;
    this.target1.style.filter = 'alpha(opacity = 0)';

    if (!this.target1.parentNode)
    {
        this.insertElement(this.target1);
    }
};


//setup variables and play
HTMLFade.prototype.begin = function()
{

    if (this.target1 && this.target1.parentNode)
    {
        this.target1.parentNode.removeChild(this.target1);
    }
    if (this.target0 && this.target0.parentNode)
    {
        this.target0.parentNode.removeChild(this.target0);
    }

    if (this.target0)
    {
        this.insertElement(this.target0);
    }
    if (this.target1)
    {
        this.insertElement(this.target1);
    }
    window.updateLayout();
};

HTMLFade.prototype.end = function()
{
    if (!this.target1)
    {
        this.target0.style.opacity = 1.0;
        this.target0.style.filter = 'alpha(opacity = 100)';
        return; //not loaded yet or only one image
    }

    this.target1.style.opacity = 1.0;
    this.target1.style.filter = 'alpha(opacity = 100)';

    if (this.target0 && this.target0.parentNode == this.viewport)
    {
        this.viewport.removeChild(this.target0);
    }
};

//Paint transition at value (between 0.0-1.0)
HTMLFade.prototype.paint = function(value)
{
    //adjust opacity of target Images
    if (this.target1)
    {
        this.target1.style.opacity = 1.0;
        this.target1.style.filter = 'alpha(opacity = 100)';
    }

    if (this.target0)
    {
        this.target0.style.opacity = (1 - value);
        this.target0.style.filter = 'alpha(opacity = ' + ((1 - value) * 100) + ')';
    }
};
// end HTMLFade
//////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////
//Shatter transition
function Shatter(canvas, target0, target1)
{
    this.canvas = canvas
    this.triangles = new Array();
    this.vectors = new Array();
    this.setTarget0(target0)
    this.setTarget1(target1);
}
;

Shatter.prototype.setTarget0 = function(target)
{
    this.target0 = target;
};

Shatter.prototype.setTarget1 = function(target)
{
    this.target1 = target;
};

//constants
// how many shards to create
Shatter.NUM_SHARDS = 100;
// max value of random speed for each shard
Shatter.MAX_SHARD_SPEED = 18;
// rgba fill color for shard shadows
Shatter.SHADOW_COLOR = "rgba(0, 0, 0, 0.4);";
// x & y pixel offset for shard shadows
Shatter.SHADOW_OFFSET = 5;

//setup variables and play
Shatter.prototype.begin = function()
{
    var idx = 0;
    var x = 0;
    var y = 0;

    //randomize points on target0
    var _pts = new Array();
    _pts.push(new Point(0, 0));
    _pts.push(new Point(this.target0.width / 2, 0));
    _pts.push(new Point(this.target0.width, 0));
    _pts.push(new Point(0, this.target0.height));
    _pts.push(new Point(0, this.target0.height / 2));
    _pts.push(new Point(this.target0.width, this.target0.height));
    _pts.push(new Point(this.target0.width, this.target0.height / 2));
    _pts.push(new Point(this.target0.width / 2, this.target0.height));

    //randomly distibute points
    for (idx = 0; idx < Shatter.NUM_SHARDS; idx++)
    {
        x = this.target0.width * Math.random();
        y = this.target0.height * Math.random();
        _pts.push(new Point(x, y));
    }

    // create shard shapes and shadows, and trajectories for shatter animation
    if (this.target0.width > 0 && this.target0.height > 0)
    {
        this.triangles = Triangulate(_pts);
        this.vectors = new Array(this.triangles.length);

        //TODO: would creating the shard images here be better?

        //canvas center
        var cx = this.target0.width * 0.5;
        var cy = this.target0.height * 0.5;

        for (i in this.triangles)
        {
            // choose a direction and speed to send the shard
            var triangle = this.triangles[i];

            //triangle center
            var tcx = (triangle.v0.x + triangle.v1.x + triangle.v2.x) / 3;
            var tcy = (triangle.v0.y + triangle.v1.y + triangle.v2.y) / 3;

            var dx = cx - tcx;
            var dy = cy - tcy;
            var a = Math.atan2(dx, dy);

            //calculate speed based on distance. closer to middle==faster
            var vx = (Math.random() * Shatter.MAX_SHARD_SPEED) + ((1.0 - (dx / cx)) * Shatter.MAX_SHARD_SPEED);
            var vy = (Math.random() * Shatter.MAX_SHARD_SPEED) + ((1.0 - (dy / cy)) * Shatter.MAX_SHARD_SPEED);

            this.vectors[i] = new Vector(-Math.sin(a) * vy, -Math.cos(a) * vx);
        }
    }

    //DEBUG: draw triangles
    // var context = this.canvas.getContext('2d');
    // context.beginPath();
    // context.strokeStyle = 'red';
    // for(i in this.triangles ) {
    // // choose a direction and speed to send the shard
    // var triangle = this.triangles[i];
    // context.moveTo(triangle.v0.x, triangle.v0.y);
    // context.lineTo(triangle.v1.x, triangle.v1.y);
    // context.lineTo(triangle.v2.x, triangle.v2.y);
    // context.lineTo(triangle.v0.x, triangle.v0.y);
    // }
    // context.stroke();
};

Shatter.prototype.end = function()
{
    if (!this.target1)
    {
        return; //not loaded yet or only one image
    }

    var context = this.canvas.getContext('2d');
    context.drawImage(this.target1, 0, 0, this.canvas.width, this.canvas.height);
}

//Paint transition at value (between 0.0-1.0)
Shatter.prototype.paint = function(value)
{
    var context = this.canvas.getContext('2d');
    if (!this.target1)
    {
        context.drawImage(this.target0, 0, 0, this.canvas.width, this.canvas.height);
        return; //not loaded yet
    }

    context.drawImage(this.target1, 0, 0, this.canvas.width, this.canvas.height);

    //scale
    var sx = this.canvas.width / this.target0.width;
    var sy = this.canvas.height / this.target0.height;
    context.save();
    context.scale(sx, sy);

    for (i in this.triangles)
    {
        var triangle = this.triangles[i];
        var vector = this.vectors[i];
        var x = vector.pathX * (value * Shatter.MAX_SHARD_SPEED);
        var y = vector.pathY * (value * Shatter.MAX_SHARD_SPEED);
        var bounds = triangle.bounds();

        // //draw shadow to canvas
        // context.save();
        // context.translate(x,y);
        // context.shadowOffsetX = Shatter.SHADOW_OFFSET;
        // context.shadowOffsetY = Shatter.SHADOW_OFFSET;
        // context.shadowBlur = Shatter.SHADOW_OFFSET;
        // context.shadowColor = Shatter.SHADOW_COLOR;
        // context.fillStyle = "#FFFFFF";
        // context.fill();
        // context.beginPath();
        // context.moveTo(triangle.v0.x,triangle.v0.y);
        // context.lineTo(triangle.v1.x,triangle.v1.y);
        // context.lineTo(triangle.v2.x,triangle.v2.y);
        // context.lineTo(triangle.v0.x,triangle.v0.y);
        // context.closePath();
        // context.restore();

        //draw clipped image to canvas
        context.save();
        context.translate(x, y);
        context.beginPath();
        context.moveTo(triangle.v0.x, triangle.v0.y);
        context.lineTo(triangle.v1.x, triangle.v1.y);
        context.lineTo(triangle.v2.x, triangle.v2.y);
        context.lineTo(triangle.v0.x, triangle.v0.y);
        context.clip();
        context.drawImage(this.target0, bounds.x, bounds.y, bounds.width, bounds.height, bounds.x, bounds.y, bounds.width, bounds.height);
        context.restore();
    }
    context.restore();
};

// end Shatter
//////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////
//Fade transition
function Fade(canvas, target0, target1)
{
    this.canvas = canvas
    this.setTarget0(target0)
    this.setTarget1(target1);
}
;

Fade.prototype.setTarget0 = function(target)
{
    this.target0 = target;
};

Fade.prototype.setTarget1 = function(target)
{
    this.target1 = target;
};


//setup variables and play
Fade.prototype.begin = function()
{
    var context = this.canvas.getContext('2d');
    context.drawImage(this.target0, 0, 0, this.canvas.width, this.canvas.height);
};
//nothing to do

Fade.prototype.end = function()
{
    if (!this.target1)
    {
        return; //not loaded yet or only one image
    }

    var context = this.canvas.getContext('2d');
    context.drawImage(this.target1, 0, 0, this.canvas.width, this.canvas.height);
}

//Paint transition at value (between 0.0-1.0)
Fade.prototype.paint = function(value)
{
    var context = this.canvas.getContext('2d');
    var w = this.canvas.width;
    var h = this.canvas.height;

    context.save();
    context.drawImage(this.target0, 0, 0, w, h);
    context.globalAlpha = value;
    if (this.target1)
        context.drawImage(this.target1, 0, 0, w, h);
    context.restore();
};
// end Fade
//////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////
//Swivel transition
function Swivel(canvas, target0, target1)
{
    this.canvas = canvas
    this.setTarget0(target0)
    this.setTarget1(target1);

    this.origWidth0 = this.target0.width;
    this.origHeight0 = this.target0.height;
    this.origX0 = 0;
    this.origY0 = 0;
    this.origScaleX0 = 1;
    this.origScaleY0 = 1;

    //target1 may not be loaded yet
    this.origWidth1 = 0;
    this.origHeight1 = 0;
    if (this.target1 && this.target1.width > 0 && this.target1.height > 0)
    {
        this.origWidth1 = this.target1.width;
        this.origHeight1 = this.target1.height;
    }
    if (this.origWidth1 <= 0 || this.origHeight1 <= 0)
    {
        this.origWidth1 = this.origWidth0;
        this.origHeight1 = this.origHeight0;
    }

    this.origX1 = 0;
    this.origY1 = 0;
    this.origScaleX1 = 1;
    this.origScaleY1 = 1;
}
;

Swivel.prototype.setTarget0 = function(target)
{
    this.target0 = target;
};

Swivel.prototype.setTarget1 = function(target)
{
    this.target1 = target;
};

//setup variables and play
Swivel.prototype.begin = function()
{
};

Swivel.prototype.end = function()
{
    if (!this.target1)
    {
        return; //not loaded yet or only one image
    }

    var context = this.canvas.getContext('2d');
    context.drawImage(this.target1, 0, 0, this.canvas.width, this.canvas.height);
}

//Paint transition at value (between 0.0-1.0)
Swivel.prototype.paint = function(value)
{
    var context = this.canvas.getContext('2d');
    context.save();
    context.fillStyle = 'white';
    context.fillRect(0, 0, context.canvas.width, context.canvas.height);

    if (!this.target1)
    {
        context.drawImage(this.target0, 0, 0, context.canvas.width, context.canvas.height);
        context.restore();
        return; //not loaded yet
    }

    var sx = this.canvas.width / this.target0.width;
    var sy = this.canvas.height / this.target0.height;
    context.scale(sx, sy);

    var w0 = this.target0.width;
    var h0 = this.target0.height;
    var w1 = this.target1.width;
    var h1 = this.target1.height;
    if (value > 0.5)
    {

        this.paintTarget(context, this.target0, -(1 - value), w0, h0, 0, 0, 1, 1);
        this.paintTarget(context, this.target1, value, w1, h1, 0, 0, 1, 1);
    } else {

        this.paintTarget(context, this.target1, value, w1, h1, 0, 0, 1, 1);
        this.paintTarget(context, this.target0, -(1 - value), w0, h0, 0, 0, 1, 1);
    }
    context.restore();
};

Swivel.prototype.paintTarget = function(context, target, val, width, height, x, y, sx, sy)
{
    //update the target
    var offsetX = (width * 0.5) * Math.sin(val * Math.PI);
    val = Math.abs(val);

    var ratioX = val / sx;
    var ratioY = val / sy;

    var newOriginX = (width * 0.5) * ratioX;
    var newOriginY = (height * 0.5) * ratioY;

    var newX = (width * 0.5) - newOriginX + x + offsetX;
    var newY = (height * 0.5) - newOriginY + y;
    newX = Number(newX.toFixed(1));
    newY = Number(newY.toFixed(1));

    var newWidth = width * val;
    var newHeight = height * val;
    var reflectionHeight = newHeight * 0.25;
    var reflectionSrcHeight = height * 0.25;

    //var context = this.canvas.getContext('2d');
    context.drawImage(target, x, y, width, height, newX, newY, newWidth, newHeight);
    context.save();

    context.translate(0, height - 1);
    context.scale(1, -1);
    context.drawImage(target, x, y, width, height, newX, newY - newHeight, newWidth, newHeight);

    var gradient = context.createLinearGradient(0, newY - newHeight, 0, newY + newHeight);
    gradient.addColorStop(0.0, "rgba(255, 255, 255, 1.0)");
    gradient.addColorStop(0.5, "rgba(255, 255, 255, 0.8)");
    gradient.addColorStop(1.0, "rgba(255, 255, 255, 0.4)");

    context.fillStyle = gradient;
    context.fillRect(newX - 2, newY - newHeight - 2, newWidth + 4, newHeight + 4);

    context.restore();
};
// end Swivel
//////////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////////
// Controls
function Controls(manager)
{
    this.manager = manager;

    this.status = 'off'; // one of 'on', 'off', 'timer'
    this.statusTimer = null; // status -> off when this timer runs out
    this.animationTimer = null;
    this.animationAmount = 0;
    this.active = false;
    this.lastToggleTimeStamp = 0;
    
    //control button reference
    this.prevButton = null;
    this.nextButton = null;
    this.pauseButton = null;
    this.playButton = null;
    this.loader = null;


    if (pages.length > 1 || hasPageSounds)
    {
        this.active = true;
        this.addControls();
        if (autohideControls)
        {
            this.addMouseListeners();
        }
        document.getElementById('control_box').style.visibility = 'visible';
    }
}

Controls.prototype.addControls = function()
{
    var controlHTML 
        = "<div id=\"control_grid\" class=\"cntrl_grd\">\n\
            <table cellpadding=\"2\" cellspacing=\"0\" border=\"0\">\n\
                <tr>\n\
                    <td><img id=\"enterFullScreen\" style=\"padding:1px;opacity:1;\" src=\"images/ctrlenterfullscreen.png\" alt=\"Show Full Screen\"><img id=\"exitFullScreen\" style=\"padding:1px;opacity:1;\" src=\"images/ctrlexitfullscreen.png\" alt=\"Exit Full Screen\"></td>\n\
                    <td id=\"controlSpacer\" width=\"100%\" align=\"right\" valign=\"middle\">\n\<span id=\"page_status\" style=\"font-family:sans-serif;\"></span>&nbsp;</td>\n\
                    <td><img id=\"loader\" style=\"padding:1px; opacity:1;\" src=\"images/loader.gif\" alt=\"Loading\"></td>\n\
                    <td><img id=\"prevButton\" style=\"padding:1px; opacity:1;\" src=\"images/ctrlprevious.png\" alt=\"Previous\"></td>\n\
                    <td><img id=\"pauseButton\" style=\"padding:1px;display:none; opacity:1;\" src=\"images/ctrlpause.png\" alt=\"Pause\"><img id=\"playButton\" style=\"padding:1px;display:none; opacity:1;\" src=\"images/ctrlplay.png\" alt=\"Play\"></td>\n\
                    <td><img id=\"nextButton\" style=\"padding:1px; opacity:1;\" src=\"images/ctrlnext.png\" alt=\"Next\"></td>\n\
                </tr></table></div>";

    this.cntrlDiv = document.createElement('div');
    this.cntrlDiv.setAttribute('id', 'control_box');
    this.cntrlDiv.setAttribute('align', 'right');

    this.cntrlDiv.style.position = "absolute";

    if (bIsAndroid)
    {
        this.cntrlDiv.style.left = "-7px";
    }

    this.cntrlDiv.style.left = "0px";
    this.cntrlDiv.style.bottom = "14px";
    this.cntrlDiv.style.width = "100%";
    this.cntrlDiv.style.height = "42px";

    this.cntrlDiv.innerHTML = controlHTML;

    document.getElementById('viewport').appendChild(this.cntrlDiv);

    //setup buttons
    this.prevButton = document.getElementById('prevButton');
    this.nextButton = document.getElementById('nextButton');
    this.pauseButton = document.getElementById('pauseButton');
    this.playButton = document.getElementById('playButton');
    this.enterFullScreen = document.getElementById('enterFullScreen');
    this.exitFullScreen = document.getElementById('exitFullScreen');
    this.loader = document.getElementById('loader');

    this.addButtonListeners(this.prevButton);
    this.addButtonListeners(this.nextButton);
    this.addButtonListeners(this.pauseButton);
    this.addButtonListeners(this.playButton);
    this.addButtonListeners(this.enterFullScreen);
    this.addButtonListeners(this.exitFullScreen);

    this.loader.style.display = 'none';
    this.exitFullScreen.style.display = 'none';
    if (!supportsFullScreen()) {
        this.enterFullScreen.style.display = 'none';
    }
    setInterval(monitorFullScreen, 250);
}

Controls.prototype.addButtonListeners = function(button)
{
    button.onclick = function(e) {
        manager.controls.buttonClick(e);
    };
    button.onmouseover = function(e) {
        manager.controls.buttonHover(e);
    };
    button.onmousedown = function(e) {
        manager.controls.buttonPressed(e);
    };
    button.onmouseout = function(e) {
        manager.controls.buttonReset(e);
    };
    button.onmouseup = function(e) {
        manager.controls.buttonHover(e);
    };
}

Controls.prototype.buttonClick = function(e)
{
    if (!e)
    {
        e = window.event;
    }
    var button = (e.target) ? e.target : e.srcElement;
    if (button.style.opacity < 1)
    {
        return; //disabled
    }

    if (button == this.prevButton)
    {
        this.manager.previous();
    } else if (button == this.nextButton) {
        this.manager.next();
    } else if (button == this.pauseButton) {
        this.manager.pause();
    } else if (button == this.playButton) {
        this.manager.start();
    } else if (button == this.enterFullScreen) {
        this.manager.enterFullScreen();
    } else if (button == this.exitFullScreen) {
        this.manager.exitFullScreen();
    }
}

Controls.prototype.update = function()
{
    if (!this.active)
        return;

    //update status and controls
    var cb = document.getElementById('control_box');
    if (!cb)
    {
        return;
    }

    var busy = (this.manager.getWorkStatus() == WORK_STATUS_LOADING) || (this.manager.getWorkStatus() == WORK_STATUS_BUSY);

    this.setButtonStatus(this.prevButton, !busy);
    this.setButtonStatus(this.nextButton, !busy);
    this.setButtonStatus(this.pauseButton, !busy);
    this.setButtonStatus(this.playButton, !busy);

    if (busy)
    {
        document.getElementById("page_status").innerHTML = "";
        if (this.manager.getWorkStatus() == WORK_STATUS_LOADING)
        {
            this.loader.style.display = 'inline';
            return;
        }
    }

    this.loader.style.display = 'none';

    var idx = this.manager.currentIndex;
    var aut = pages[idx][2];

    //update label
//    document.getElementById("page_status").innerHTML = "Page " + (idx + 1) + " of " + pages.length;

    //update prev/next buttons
    if (pages.length > 1)
    {
        if (!looping)
        {
            if (idx == 0)
            {
                //disable previous button
                this.setButtonStatus(this.prevButton, false);
                this.setButtonStatus(this.nextButton, true);
            } else if (idx >= pages.length - 1) {
                //disable next button
                this.setButtonStatus(this.prevButton, true);
                this.setButtonStatus(this.nextButton, false);
            } else {
                this.setButtonStatus(this.prevButton, true);
                this.setButtonStatus(this.nextButton, true);
            }
        }
    } else {
        //no forward or backwards so disable both
        this.setButtonStatus(this.prevButton, false);
        this.setButtonStatus(this.nextButton, false);
    }

    if (autoadvance && aut > 0)
    {
        if (this.manager.getPlayStatus() == PLAY_STATUS_PLAYING)
        {
            //playing
            this.pauseButton.style.display = (!backgroundSound && aut == -1) ? 'none' : 'inline';
            this.playButton.style.display = 'none';
        } else if (this.manager.getPlayStatus() == PLAY_STATUS_PAUSED) {
            //paused
            this.pauseButton.style.display = 'none';
            this.playButton.style.display = 'inline';
        } else if (this.manager.getPlayStatus() == PLAY_STATUS_END) {
            //end
            this.pauseButton.style.display = 'none';
            this.playButton.style.display = 'inline';
        }
    } else {
        this.pauseButton.style.display = (hasPageSounds || backgroundSound) ? 'inline' : 'none';
        this.playButton.style.display = 'none';
    }
}

Controls.prototype.setButtonStatus = function(button, enabled)
{
    if (enabled)
    {
        button.style.opacity = 1;
        button.style.filter = 'alpha(opacity=100)';
    } else {
        button.style.opacity = .25;
        button.style.filter = 'alpha(opacity=25)';
    }
}

Controls.prototype.buttonHover = function(e)
{
    if (!e)
    {
        e = window.event;
    }
    var button = (e.target) ? e.target : e.srcElement;
    if (button.style.opacity < 1)
    {
        return; //disabled
    }

    button.style.border = '1px outset #BAD2F4';
    button.style.padding = '0px';
}

Controls.prototype.buttonPressed = function(e)
{
    if (!e)
    {
        e = window.event;
    }
    var button = (e.target) ? e.target : e.srcElement;
    if (button.style.opacity < 1)
    {
        return; //disabled
    }

    button.style.border = '1px inset #BAD2F4';
    button.style.padding = '0px';
}

Controls.prototype.buttonReset = function(e)
{
    if (!e)
    {
        e = window.event;
    }
    var button = (e.target) ? e.target : e.srcElement;

    button.style.border = 'none';
    button.style.padding = '1px';
}

Controls.prototype.addMouseListeners = function()
{
    if (document.body.getAttribute("onmousemove"))
    {
        var MouseMoveCode = eval(document.body.onmousemove);
        if (navigator.userAgent.indexOf("Firefox") != -1)
        {
            var MouseMoveEvent = function(event)
            {
                this.onMouseMove(event, CustomControls.OverlayMenu.MouseMoveCode)
            };
            document.body.onmousemove = MouseMoveEvent;
        } else {
            MouseMoveEvent = function(event)
            {
                this.onMouseMove(event, MouseMoveCode())
            };
            document.body.onmousemove = MouseMoveEvent;
        }
    } else {
        var ctrls = this;
        document.body.onmousemove = function(event)
        {
            ctrls.onMouseMove(event);
        };
        document.body.onclick = function(event)
        {
            ctrls.handleToggleEvent(event);
        };
        document.body.ontouchstart = function(event)
        {
            ctrls.handleToggleEvent(event);
        };
    }
}

Controls.prototype.handleToggleEvent = function(e) {
    if (!e)
    {
        e = window.event;
    }
    var target = (e.target) ? e.target : e.srcElement;
    /// only toggle if not part of another control event
    if (this.status === 'off' 
            || this.cntrlDiv === null 
            || !this.cntrlDiv.contains(target)
            || document.getElementById('controlSpacer').contains(target))
    {
        this.toggleControls(e);
    }
};

Controls.prototype.onMouseMove = function(e)
{
    var now = new Date().getTime();
    if (now - this.lastToggleTimeStamp < 500) {
        return;
    }
    this.showControls(true);
};

Controls.prototype.toggleControls = function(e) {
    this.lastToggleTimeStamp = new Date().getTime();
    if (this.status === 'on') {
        this.hideControls();
    } else {
        this.showControls(false);
    }
};

Controls.prototype.showControls = function(temporary) {    
    if (this.status === 'on') {
        return;
    }    
    this.status = temporary ? 'timer' : 'on';
        
    if (this.statusTimer)
    {
        clearTimeout(this.statusTimer);
        this.statusTimer = 0;
    }

    if (temporary) {
        var ctrls = this;
        this.statusTimer = setTimeout(function() {
            ctrls.hideControls();
        }, 3000);
    }
    
    this.startAnimation();
};

Controls.prototype.hideControls = function() {
    this.status = 'off';
    
    if (this.statusTimer) {
        clearTimeout(this.statusTimer);
        this.statusTimer = 0;
    }
    
    this.startAnimation();
}

Controls.prototype.startAnimation = function()
{
    if (this.animationTimer) {
        return;
    }

    this.updateAnimation();
};

Controls.prototype.updateAnimation = function() {
    this.animationTimer = 0;
    var controlboxVisible = this.status !== 'off';
    var targetAmount = controlboxVisible ? 1 : 0;
    this.animationAmount = controlboxVisible ? this.animationAmount + 0.1 : this.animationAmount - 0.1;
    this.animationAmount = (this.animationAmount > 1) ? 1 : (this.animationAmount < 0) ? 0 : this.animationAmount;
    this._setControlVisibility(this.animationAmount);

    if (this.animationAmount !== targetAmount) {
        var controls = this;
        this.animationTimer = setTimeout(function() {
            controls.updateAnimation();
        }, 50);
    }
};

Controls.prototype._setControlVisibility = function(per)
{
    if (!this.active)
        return;

    //control_box
    var cb = document.getElementById('control_box');
    cb.style.opacity = per;
}


// end Controls
//////////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////////
// Delaunay
////////////////////////////////////////////////////////////////////////////////
//
// Delaunay Triangulation Code, by Joshua Bell
//
// Inspired by: http://www.codeguru.com/cpp/data/mfc_database/misc/article.php/c8901/
//
// This work is hereby released into the Public Domain. To view a copy of the public 
// domain dedication, visit http://creativecommons.org/licenses/publicdomain/ or send 
// a letter to Creative Commons, 171 Second Street, Suite 300, San Francisco, 
// California, 94105, USA.
//
////////////////////////////////////////////////////////////////////////////////

// http://www.travellermap.com/tmp/delaunay.htm


var EPSILON = 1.0e-6;

//------------------------------------------------------------
// Vertex class
//------------------------------------------------------------

function Vertex(x, y)
{
    this.x = x;
    this.y = y;

} // Vertex

//------------------------------------------------------------
// Triangle class
//------------------------------------------------------------

function Triangle(v0, v1, v2)
{
    this.v0 = v0;
    this.v1 = v1;
    this.v2 = v2;

    this.CalcCircumcircle();

} // Triangle

Triangle.prototype.CalcCircumcircle = function()
{
    // From: http://www.exaflop.org/docs/cgafaq/cga1.html

    var A = this.v1.x - this.v0.x;
    var B = this.v1.y - this.v0.y;
    var C = this.v2.x - this.v0.x;
    var D = this.v2.y - this.v0.y;

    var E = A * (this.v0.x + this.v1.x) + B * (this.v0.y + this.v1.y);
    var F = C * (this.v0.x + this.v2.x) + D * (this.v0.y + this.v2.y);

    var G = 2.0 * (A * (this.v2.y - this.v1.y) - B * (this.v2.x - this.v1.x));

    var dx, dy;

    if (Math.abs(G) < EPSILON)
    {
        // Collinear - find extremes and use the midpoint
        function max3(a, b, c)
        {
            return (a >= b && a >= c) ? a : (b >= a && b >= c) ? b : c;
        }

        function min3(a, b, c)
        {
            return (a <= b && a <= c) ? a : (b <= a && b <= c) ? b : c;
        }

        var minx = min3(this.v0.x, this.v1.x, this.v2.x);
        var miny = min3(this.v0.y, this.v1.y, this.v2.y);
        var maxx = max3(this.v0.x, this.v1.x, this.v2.x);
        var maxy = max3(this.v0.y, this.v1.y, this.v2.y);

        this.center = new Vertex((minx + maxx) / 2, (miny + maxy) / 2);

        dx = this.center.x - minx;
        dy = this.center.y - miny;
    } else {
        var cx = (D * E - B * F) / G;
        var cy = (A * F - C * E) / G;

        this.center = new Vertex(cx, cy);

        dx = this.center.x - this.v0.x;
        dy = this.center.y - this.v0.y;
    }

    this.radius_squared = dx * dx + dy * dy;
    this.radius = Math.sqrt(this.radius_squared);
}; // CalcCircumcircle

Triangle.prototype.InCircumcircle = function(v)
{
    var dx = this.center.x - v.x;
    var dy = this.center.y - v.y;
    var dist_squared = dx * dx + dy * dy;

    return (dist_squared <= this.radius_squared);

}; // InCircumcircle

Triangle.prototype.bounds = function()
{
    function max3(a, b, c)
    {
        return (a >= b && a >= c) ? a : (b >= a && b >= c) ? b : c;
    }
    function min3(a, b, c)
    {
        return (a <= b && a <= c) ? a : (b <= a && b <= c) ? b : c;
    }

    var minx = min3(this.v0.x, this.v1.x, this.v2.x);
    var miny = min3(this.v0.y, this.v1.y, this.v2.y);
    var maxx = max3(this.v0.x, this.v1.x, this.v2.x);
    var maxy = max3(this.v0.y, this.v1.y, this.v2.y);
    return new Rectangle(minx, miny, maxx - minx, maxy - miny);
};

//------------------------------------------------------------
// Edge class
//------------------------------------------------------------

function Edge(v0, v1)
{
    this.v0 = v0;
    this.v1 = v1;

} // Edge


//------------------------------------------------------------
// Triangulate
//
// Perform the Delaunay Triangulation of a set of vertices.
//
// vertices: Array of Vertex objects
//
// returns: Array of Triangles
//------------------------------------------------------------
function Triangulate(vertices)
{
    var triangles = [];

    //
    // First, create a "supertriangle" that bounds all vertices
    //
    var st = CreateBoundingTriangle(vertices);

    triangles.push(st);

    //
    // Next, begin the triangulation one vertex at a time
    //
    var i;
    for (i in vertices)
    {
        // NOTE: This is O(n^2) - can be optimized by sorting vertices
        // along the x-axis and only considering triangles that have 
        // potentially overlapping circumcircles

        var vertex = vertices[i];
        AddVertex(vertex, triangles);
    }

    //
    // Remove triangles that shared edges with "supertriangle"
    //
    for (i in triangles)
    {
        var triangle = triangles[i];

        if (triangle.v0 == st.v0 || triangle.v0 == st.v1 || triangle.v0 == st.v2 ||
                triangle.v1 == st.v0 || triangle.v1 == st.v1 || triangle.v1 == st.v2 ||
                triangle.v2 == st.v0 || triangle.v2 == st.v1 || triangle.v2 == st.v2)
        {
            delete triangles[i];
        }
    }

    return triangles;

} // Triangulate


// Internal: create a triangle that bounds the given vertices, with room to spare
function CreateBoundingTriangle(vertices)
{
    // NOTE: There's a bit of a heuristic here. If the bounding triangle 
    // is too large and you see overflow/underflow errors. If it is too small 
    // you end up with a non-convex hull.

    var minx, miny, maxx, maxy;
    for (var i in vertices)
    {
        var vertex = vertices[i];
        if (minx === undefined || vertex.x < minx)
        {
            minx = vertex.x;
        }
        if (miny === undefined || vertex.y < miny)
        {
            miny = vertex.y;
        }
        if (maxx === undefined || vertex.x > maxx)
        {
            maxx = vertex.x;
        }
        if (maxy === undefined || vertex.y > maxy)
        {
            maxy = vertex.y;
        }
    }

    var dx = (maxx - minx) * 10;
    var dy = (maxy - miny) * 10;

    var stv0 = new Vertex(minx - dx, miny - dy * 3);
    var stv1 = new Vertex(minx - dx, maxy + dy);
    var stv2 = new Vertex(maxx + dx * 3, maxy + dy);

    return new Triangle(stv0, stv1, stv2);

} // CreateBoundingTriangle


// Internal: update triangulation with a vertex 
function AddVertex(vertex, triangles)
{
    var edges = [];

    // Remove triangles with circumcircles containing the vertex
    var i;
    for (i in triangles)
    {
        var triangle = triangles[i];

        if (triangle.InCircumcircle(vertex))
        {
            edges.push(new Edge(triangle.v0, triangle.v1));
            edges.push(new Edge(triangle.v1, triangle.v2));
            edges.push(new Edge(triangle.v2, triangle.v0));

            delete triangles[i];
        }
    }

    edges = UniqueEdges(edges);

    // Create new triangles from the unique edges and new vertex
    for (i in edges)
    {
        var edge = edges[i];

        triangles.push(new Triangle(edge.v0, edge.v1, vertex));
    }
} // AddVertex


// Internal: remove duplicate edges from an array
function UniqueEdges(edges)
{
    // TODO: This is O(n^2), make it O(n) with a hash or some such
    var uniqueEdges = [];
    for (var i in edges)
    {
        var edge1 = edges[i];
        var unique = true;

        for (var j in edges)
        {
            if (i != j)
            {
                var edge2 = edges[j];

                if ((edge1.v0 == edge2.v0 && edge1.v1 == edge2.v1) ||
                        (edge1.v0 == edge2.v1 && edge1.v1 == edge2.v0))
                {
                    unique = false;
                    break;
                }
            }
        }

        if (unique)
        {
            uniqueEdges.push(edge1);
        }
    }

    return uniqueEdges;

} // UniqueEdges

//Point class
function Point(x, y)
{
    this.x = x;
    this.y = y;

}

//Vector class
function Vector(pathX, pathY)
{
    this.pathX = pathX;
    this.pathY = pathY;

}

//Rectangle class
function Rectangle(x, y, width, height)
{
    this.x = x;
    this.y = y;
    this.width = width;
    this.height = height;
}

// end Delaunay
//////////////////////////////////////////////////////////////////////////////////////////////////
